// Copyright 2016-2022 JetBrains s.r.o.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
package com.goide

import com.intellij.openapi.progress.EmptyProgressIndicator
import com.intellij.openapi.progress.blockingContext
import com.intellij.openapi.progress.indicatorRunBlockingCancellable

fun <T> runBlockingAction(action: () -> T): T {
  return indicatorRunBlockingCancellable(EmptyProgressIndicator()) {
    blockingContext(action)
  }
}